export declare type LogLevel = "debug" | "info" | "warn" | "error";
declare type LogCallback = (error?: any, level?: string | undefined, message?: string | undefined, meta?: any) => void;
interface LogAdapter {
    log: (level: string, msg: string, details: any, cb: LogCallback) => void;
}
export interface LogOptions {
    adapter: LogAdapter;
    details: any;
    level: LogLevel;
}
export declare const enableLoggly: (apiKey: string, identifier: string, env: string) => void;
export declare const setOptions: (opts: LogOptions) => void;
export declare function log(level: LogLevel, msg: string, details: any): Promise<void>;
export declare const debug: (msg: string, details?: any) => Promise<void>;
export declare const info: (msg: string, details?: any) => Promise<void>;
export declare const warn: (msg: string, details?: any) => Promise<void>;
export declare const error: (msg: string, details?: any) => Promise<void>;
export {};
