"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const winston_loggly_bulk_1 = require("winston-loggly-bulk");
const winston = require("winston");
var logger = {
    adapter: winston,
    details: {},
    level: "debug"
};
winston.addColors({
    silly: 'magenta',
    debug: 'blue',
    verbose: 'cyan',
    info: 'green',
    warn: 'yellow',
    error: 'red'
});
const console = new winston.transports.Console({
    level: logger.level,
    format: winston.format.combine(winston.format.prettyPrint({ colorize: true, }))
});
winston.remove(winston.transports.Console);
winston.add(console);
exports.enableLoggly = (apiKey, identifier, env) => {
    winston.add(new winston_loggly_bulk_1.Loggly({
        inputToken: apiKey,
        subdomain: 'quikserve',
        tags: [env, identifier],
        json: true
    }));
};
exports.setOptions = (opts) => {
    logger = Object.assign({}, logger, opts);
};
function log(level, msg, details) {
    return new Promise((resolve) => {
        logger.adapter.log(level, msg, Object.assign({}, details, logger.details), resolve);
    });
}
exports.log = log;
exports.debug = (msg, details = {}) => __awaiter(this, void 0, void 0, function* () { return log("debug", msg, details); });
exports.info = (msg, details = {}) => __awaiter(this, void 0, void 0, function* () { return log("info", msg, details); });
exports.warn = (msg, details = {}) => __awaiter(this, void 0, void 0, function* () { return log("warn", msg, details); });
exports.error = (msg, details = {}) => __awaiter(this, void 0, void 0, function* () { return log("error", msg, details); });
